#include "snipe2d.h"
#include <pwd.h>

extern PREFS gPrefs;
SCORES gHiScore;
char uName[9];
extern int gScore;
char names[10][9];
int scores[10];

extern void fillrect (int x1, int y1, int x2, int y2, int color);

void show_hiscores()
{
    struct passwd *pw_ent = getpwuid(geteuid());
    char spath[256];  // laziness.  no $HOME should be 256 bytes long.
    FILE *f;
    int i;

    gGameState = 0;
    SDL_ShowCursor (1);
    snprintf (spath, 256, "%s/.oes/scores.bin", pw_ent->pw_dir);
    spath[255] = '\0'; // just to be safe, eh?
    f = fopen (spath, "rb");
    if (f)
	{
	    fread (&gHiScore, sizeof(SCORES), 1, f);
	    fclose (f);
	}

    gGameState = 0;
    fillrect(0,0,640,480,0);
    fillrect(19,59,621,421,0x007f00);
    fillrect(20,60,620,420,0x003f00);
    fillrect(19,80,621,81,0x007f00);
    print(224 + 12, 412, COLOR_GREEN, "click to play | press ESC to quit");
    int row = 88 +40;

    printShadow (30, row, "  Top Ten (Difficulty: Easy");
    row += 8;
    for (i = 0; i < 10; i++)
	{
	    printShadow (24, row, gHiScore.easy_n[i]);
	    snprintf (spath, 256, "%d", gHiScore.easy_s[i]);
	    if (gHiScore.easy_s[i])
		printShadow (24+48, row, spath);
	    row += 8;
	}
    row = 88+40;

    printShadow (250, row, "Top Ten (Difficulty: Medium)");
    row += 8;
    for (i = 0; i < 10; i++)
	{
	    printShadow (250, row, gHiScore.medium_n[i]);
	    snprintf (spath, 256, "%d", gHiScore.medium_s[i]);
	    if (gHiScore.medium_s[i])
		printShadow (298, row, spath);
	    row += 8;
	}
    row = 88+40;

    printShadow (476, row, " Top Ten (Difficulty: Hard)");
    row += 8;
    for (i = 0; i < 10; i++)
	{
	    printShadow (476, row, gHiScore.hard_n[i]);
	    snprintf (spath, 256, "%d", gHiScore.hard_s[i]);
	    if (gHiScore.hard_s[i])
		printShadow (476+48, row, spath);
	    row += 8;
	}
    row = 88+40;

    SDL_Flip (gScreen);
}

void shove_hiscores(int pos) // Shift scorecard down, bump last one.
{
    int i;

    for (i = 9; i > pos; i--)
	if (i > 0)
	    {
		snprintf (names[i], 9, "%s", names[i-1]);
		names[i][8] = '\0';
		scores[i] = scores[i-1];
	    }

    scores[i] = gScore;
    snprintf (names[i], 9, "%s", uName);
    names[i][8] = '\0';
}

void init_hiscores()
{
    char path[256];
    struct passwd *pw_ent = getpwuid (geteuid());
    FILE *f;

    memset (&gHiScore, 0, sizeof(SCORES));
    snprintf (uName, 9, "%s", getenv("USER"));
    uName[8] = '\0';

    snprintf (path, 256, "%s/.oes/scores.bin", pw_ent->pw_dir);
    path[255] = '\0';
    f = fopen (path, "rb");
    if (f)
	{
	    fread (&gHiScore, sizeof(SCORES), 1, f);
	    fclose (f);
	}
}

void save_hiscores()
{
    struct passwd *pw_ent = getpwuid(geteuid());
    char path[strlen(pw_ent->pw_dir) + 1 + 16 + 1];

    snprintf (path, strlen(pw_ent->pw_dir)+18, "%s/.oes/scores.bin", pw_ent->pw_dir);
    FILE *f = fopen (path, "wb");
    if (!f)
	{
	    fprintf (stderr, "Unable to open hiscore file.  Ignoring...\n");
	    return;
	}
    fwrite (&gHiScore, sizeof (SCORES), 1, f);
    fclose (f);
}

void process_hiscore()
{
    int i;

    if (gScore < 0)
	return;
    if (gPrefs.difficulty == 1)
	{
	    memcpy (&scores, &gHiScore.easy_s, sizeof(int)*10);
	    memcpy (&names, &gHiScore.easy_n, sizeof(char)*90);
	}
    else if (gPrefs.difficulty == 2)
	{
	    memcpy (&scores, &gHiScore.medium_s, sizeof(int)*10);
	    memcpy (&names, &gHiScore.medium_n, sizeof(char)*90);
	}
    else
	{
	    memcpy (&scores, &gHiScore.hard_s, sizeof(int)*10);
	    memcpy (&names, &gHiScore.hard_n, sizeof(char)*90);
	}
    for (i = 0; i < 10; i++)
	if (gScore > scores[i])
	    break;

    if (i > 9)
	return;

    shove_hiscores(i);

    if (gPrefs.difficulty == 1)
	{
	    memcpy (&gHiScore.easy_s, &scores, sizeof(int)*10);
	    memcpy (&gHiScore.easy_n, &names, sizeof(char)*90);
	}
    else if (gPrefs.difficulty == 2)
	{
	    memcpy (&gHiScore.medium_s, &scores, sizeof(int)*10);
	    memcpy (&gHiScore.medium_n, &names, sizeof(char)*90);
	}
    else
	{
	    memcpy (&gHiScore.hard_s, &scores, sizeof(int)*10);
	    memcpy (&gHiScore.hard_n, &names, sizeof(char)*90);
	}

    save_hiscores();
}


