#include "snipe2d.h"
#include <pwd.h>

extern PREFS gPrefs;
extern char *mediaPath;
const int longest_ini_line = 256;
unsigned pversion; // The version the conf file shows.
const unsigned cversion = 1; // The unchanging version number
struct passwd *pw_ent = getpwuid(geteuid());

void new_prefs()
{
    char datadir[(strlen(pw_ent->pw_dir)+6)];
    char path[(strlen(pw_ent->pw_dir)+6+11)];

    snprintf (datadir, strlen(pw_ent->pw_dir)+6, "%s/.oes", pw_ent->pw_dir);
    snprintf (path, strlen(pw_ent->pw_dir)+17, "%s/.oes/conf.bin",
	      pw_ent->pw_dir);

    {
	FILE *dir = fopen (datadir, "r");
	if (!dir)
	    {
		mkdir (datadir, 0755);
		dir = fopen (datadir, "r");
		if (!dir)
		    {

			fprintf (stderr, "Unable to create personal prefs dir\n");
			exit (1);
		    }
	    }
	fclose (dir);
    }

    gPrefs.fullscreen = 1;
    gPrefs.audio = 1;
    gPrefs.verbose = 2;
    gPrefs.difficulty = 2;
    gPrefs.path = strdup (path);

    gPrefs.f = fopen (path, "r");
    if (!gPrefs.f)
	{
	    gPrefs.f = fopen (path, "wb");
	    if (!gPrefs.f)
		{
		    fprintf (stderr, "Error creating user prefs\n");
		    exit (1);
		}
	    fwrite ((void*)&pversion, sizeof(unsigned), 1, gPrefs.f);
	    fwrite ((void*)&gPrefs.fullscreen, sizeof(char), 1, gPrefs.f);
	    fwrite ((void*)&gPrefs.audio, sizeof(char), 1, gPrefs.f);
	    fwrite ((void*)&gPrefs.verbose, sizeof(char), 1, gPrefs.f);
	    fwrite ((void*)&gPrefs.difficulty, sizeof(char), 1, gPrefs.f);
	}

    fclose (gPrefs.f);
}

void load_prefs()
{
    FILE *f;

    new_prefs();

    f = fopen (gPrefs.path, "rb");
    fread (&pversion, sizeof(unsigned), 1, f);
    switch (pversion)
	{
	case 0: // first version of conf file
	    fread ((void*)&gPrefs.fullscreen, sizeof(char), 1, f);
	    fread ((void*)&gPrefs.audio, sizeof(char), 1, f);
	    fread ((void*)&gPrefs.verbose, sizeof(char), 1, f);
	    break;
	case 1:
	    fread ((void*)&gPrefs.fullscreen, sizeof(char), 1, f);
	    fread ((void*)&gPrefs.audio, sizeof(char), 1, f);
	    fread ((void*)&gPrefs.verbose, sizeof(char), 1, f);
	    fread ((void*)&gPrefs.difficulty, sizeof(char), 1, f);
	    break;
	default:
	    fprintf (stderr, "Unknown config file version: %u\n", pversion);
	    exit (1);
	}

    atexit (save_prefs);
}

void save_prefs()
{
    FILE *f = fopen (gPrefs.path, "w");

    update_prefs();

    fwrite ((void*)&cversion, sizeof(unsigned), 1, f);
    fwrite ((void*)&gPrefs.fullscreen, sizeof(char), 1, f);
    fwrite ((void*)&gPrefs.audio, sizeof(char), 1, f);
    fwrite ((void*)&gPrefs.verbose, sizeof(char), 1, f);
    fwrite ((void*)&gPrefs.difficulty, sizeof(char), 1, f);

    fclose (f);
}

void prefs() {
    SDL_Surface *screen = SDL_DisplayFormat (gScreen); // BAD.  don't do this.
    SDL_Surface *fullscreen = gButton.fullscreen;
    SDL_Surface *audio = gButton.audioon;
    SDL_Surface *skill = gButton.easy;
    SDL_Surface *fullscreenh = gButton.fullscreenh;
    SDL_Surface *audioh = gButton.audioonh;
    SDL_Surface *skillh = gButton.easyh;
    SDL_Event e;

    switch (gPrefs.difficulty)
	{
	case 1:
	    skill = gButton.easy;
	    skillh = gButton.easyh;
	    break;
	case 2:
	    skill = gButton.medium;
	    skillh = gButton.mediumh;
	    break;
	case 3:
	    skill = gButton.hard;
	    skillh = gButton.hardh;
	    break;
	}
    if (!gPrefs.audio)
	{
	    audio = gButton.audiooff;
	    audioh = gButton.audiooffh;
	}
    if (!gPrefs.fullscreen)
	{
	    fullscreen = gButton.window;
	    fullscreenh = gButton.windowh;
	}

    while (1)
	{
	    if (SDL_PollEvent(&e))
		{
		    switch (e.type)
			{
			case SDL_MOUSEBUTTONUP:
			    if (hovering (238, 102, 174, 24))
				{
				    if (gPrefs.fullscreen)
					{
					    gPrefs.fullscreen = false;
					    fullscreen = gButton.window;
					    fullscreenh = gButton.windowh;
					    SDL_WM_ToggleFullScreen (gScreen);
					} else {
					    gPrefs.fullscreen = true;
					    fullscreen = gButton.fullscreen;
					    fullscreenh = gButton.fullscreenh;
					    SDL_WM_ToggleFullScreen (gScreen);
					}
				}
			    if (hovering (238, 166, 174, 24))
				{
				    if (gPrefs.audio)
					{
					    gPrefs.audio = false;
					    audio = gButton.audiooff;
					    audioh = gButton.audiooffh;
					} else {
					    gPrefs.audio = true;
					    audio = gButton.audioon;
					    audioh = gButton.audioonh;
					}
				}
			    if (hovering (238, 230, 174, 24))
				{
				    gPrefs.difficulty++;
				    if (gPrefs.difficulty > 3)
					gPrefs.difficulty = 1;

				    switch (gPrefs.difficulty)
					{
					case 1:
					    skill = gButton.easy;
					    skillh = gButton.easyh;
					    break;
					case 2:
					    skill = gButton.medium;
					    skillh = gButton.mediumh;
					    break;
					case 3:
					    skill = gButton.hard;
					    skillh = gButton.hardh;
					    break;
					}
				}
			    if (hovering (238, 296, 174, 24))
				goto prefs_exitry;
			    if (hovering (238, 360, 174, 24))
				{
				    std::cout<<"Exiting normally\n";
				    exit (0);
				}
			    break;
			}
		}
	    if (!hovering(238, 102, 174, 24))
		draw_button (fullscreen, 222, 96);
	    else
		draw_button (fullscreenh, 222, 96);
	    if (!hovering(238, 166, 174, 24))
		draw_button (audio, 222, 160);
	    else
		draw_button (audioh, 222, 160);
	    if (!hovering (238, 230, 174, 24))
		draw_button (skill, 222, 224);
	    else
		draw_button (skillh, 222, 224);
	    if (!hovering (238, 296, 174, 24))
		draw_button (gButton.resume, 222, 288);
	    else
		draw_button (gButton.resumeh, 222, 288);
	    if (!hovering (238, 360, 174, 24)) 
		draw_button (gButton.quit, 222, 352);
	    else
		draw_button (gButton.quith, 222, 352);
	    SDL_Flip (gScreen);
	}
 prefs_exitry:
    SDL_BlitSurface (screen, NULL, gScreen, NULL);
    SDL_Flip (gScreen);
    SDL_FreeSurface (screen);
    return;
}


