///////////////////////////////////////////////
// 
//  Snipe2d ludum dare 48h compo entry
//
//  Jari Komppa aka Sol 
//  http://iki.fi/sol
// 
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
//
///////////////////////////////////////////////
//
// Houses are taken from a satellite picture of glasgow.
//
// The sources are a mess, as I didn't even try to do anything
// really organized here.. and hey, it's a 48h compo =)
//

#include "snipe2d.h"
//#include <getopt.h>

SDL_Surface *gScreen;
SDL_Surface *gMap;
SDL_Surface *gAIMap;
SDL_Surface *gFont[5];

float gMouseX = 0, gMouseY = 0, gMouseZ = 1.0f, gCoordScale = 1.0f;
float gWobbleX, gWobbleY, gCenterX, gCenterY;
int gControlState = 0;

int gCharacterCount;
CHARACTER *gCharacter;
SPAWNPOINT *gSpawnpoint;
WAYPOINT *gWaypoint;
PREFS gPrefs;
int gWaypointCount;
int gSpawnpointCount;
int gStartTick;
int gFrameCount;
int gLastTick;
int gGameStartTick;
int gBeforePauseTick;
int gAfterPauseTick;
int gReloading = 0;
int gScore = 0;
int verbosity = 2;
int gPauseP = 0;
int gGrabP = 1;
float gVIPSpawnTime;
float gVIPSpawnTimePeriod;
float gBadGuySpawnTime;
float gBadGuySpawnTimePeriod;
int gVIPCount = 0;
int gBadGuyCount = 0;
int gWobbleIndex;
int gGameState;
int gPedestrianSpawnCount = 0;
int gBadGuySpawnCount = 0;
int gVIPSpawnCount = 0;
int gVIPsGottenToSafety = 0;
int gPedestriansKilled = 0;
int gBadGuisKilled = 0;
SDL_Surface *gCharSprite;
CHARACTER *gSightedCharacter = NULL;
char *mediaPath;

SDL_AudioSpec *gAudioSpec = NULL;
Mix_Chunk *gAudioZoomSample = NULL;
Mix_Chunk *gAudioFireSample = NULL;
Mix_Chunk *gAudioZoomOut = NULL;
Mix_Chunk *gAudioZoomIn = NULL;
Mix_Chunk *gAudioFire = NULL;
//Mix_Music *gAudioBGM = NULL;
int gAudioZoomSampleLen = 0;
int gAudioZoomOutLen = 0;
int gAudioZoomInLen = 0;
int gAudioZoomOfs = 0;
int gAudioFireOfs = 0;
int gAudioFireSampleLen = 0;
int gAudioFireLen = 0;
static const char *crosshairs_xpm[] = {
  "    16    16        3            1",
  "X c #000000",
  ". c #ffffff",
  "  c None",
  "               ",
  "       .       ",
  "     .....     ",
  "    .  .  .    ",
  "   .   .   .   ",
  "  .         .  ",
  "  .         .  ",
  " ....  .  .... ",
  "  .         .  ",
  "  .         .  ",
  "   .   .   .   ",
  "    .  .  .    ",
  "     .....     ",
  "       .       ",
  "               ",
  "               ",
  "8,8"
};

int gPlaySound = 0;
int screen_shot_number=1;
int RELOAD_TIME = 3000;
float SCORE_MOD = 1.0;
char *invocation;

BUTTONS gButton;

const char *usage = "Orbital Eunuchs Sniper is licensed under the same terms as the ZLIB license.\nOrbital Eunuchs Sniper recognizes the following command parameters:\n  -n       | --noaudio           Start without sound\n  -f       | --fullscreen        Start in fullscreen mode\n  -w       | --window            Start in a window\n  -a       | --audio             Start with sound\n  -d 1|2|3 | --difficulty 1|2|3  Set difficulty level (1 is easiest)\n  -h       | --help              Display this help message and exit\n\n";

static SDL_Cursor *init_system_cursor(const char *image[])
{
    int i, row, col;
    Uint8 data[4*16];
    Uint8 mask[4*16];
    int hot_x, hot_y;
    
    i = -1;
    for ( row=0; row<16; ++row ) {
	for ( col=0; col<16; ++col ) {
	    if ( col % 8 ) {
		data[i] <<= 1;
		mask[i] <<= 1;
	    } else {
		++i;
		data[i] = mask[i] = 0;
	    }
	    switch (image[4+row][col]) {
	    case 'X':
		data[i] |= 0x01;
		mask[i] |= 0x01;
		break;
	    case '.':
		mask[i] |= 0x01;
		break;
	    case ' ':
		break;
	    }
	}
    }
    sscanf(image[4+row], "%d,%d", &hot_x, &hot_y);
    return SDL_CreateCursor(data, mask, 16, 16, hot_x, hot_y);
}

void set_crosshair_cursor()
{
    SDL_Cursor *crosshairs_cursor = init_system_cursor (crosshairs_xpm);

    SDL_SetCursor (crosshairs_cursor);
}






static void BGM_loop();  /* Forward declaration. */

SniperBGM::SniperBGM()
{
    BGM = NULL;
    playp = 0;
    pausep = 0;
}

SniperBGM::SniperBGM(Mix_Music *m)
{
    SniperBGM();
    BGM = m;
}

SniperBGM::~SniperBGM()
{
    stop();  /* Don't wait for fadeout to finish. */
    Mix_FreeMusic(BGM);
}

SniperBGM::operator Mix_Music*() const
{
  return BGM;
}

void SniperBGM::use(Mix_Music *m)
{
    BGM = m;
}

const SniperBGM & SniperBGM::operator=(Mix_Music *m)
{
    use(m);
}

void SniperBGM::start()
{
    if (BGM)
	if (Mix_PlayMusic(BGM, 0))
	    printf("Mix_PlayMusic: %s\n", Mix_GetError());
    Mix_HookMusicFinished(BGM_loop);
    playp = 1;
    startTime = SDL_GetTicks();
}

void SniperBGM::stimulate()
{
    if (playp) return;
    if (Mix_FadeInMusic(BGM, 0, FadeInTime))
	printf("Mix_PlayMusic: %s\n", Mix_GetError());
    Mix_HookMusicFinished(BGM_loop);
    playp = 1;
    startTime = SDL_GetTicks();
}

void SniperBGM::depress()
{
    Mix_HookMusicFinished(NULL);
    if (!Mix_FadeOutMusic(FadeOutTime))
	Mix_HaltMusic();
    playp = 0;
}

void SniperBGM::stop()
{
    Mix_HaltMusic();
    Mix_HookMusicFinished(NULL);
    playp = 0;
}

void SniperBGM::pause()
{
    if (pausep) {
	Mix_ResumeMusic();
    } else {
	Mix_PauseMusic();
    }
    pausep = 1 - pausep;
}

void SniperBGM::pause(int newstate)
{
    if (newstate) {
        Mix_PauseMusic();
        pausep = 1;
    } else {
        Mix_ResumeMusic();
        pausep = 0;
    }
}

void SniperBGM::jumpto(float pos)
{
    Mix_SetMusicPosition(pos);
}

void SniperBGM::rewind()
{
    Mix_RewindMusic();
}

void SniperBGM::loop()
{
    start();
    jumpto(RepeatJumpPos);
}

void SniperBGM::release()
{
  /* Prepare for release of sound device. */
  /* Figure out where in the BGM we currently are. */
  stopTime = SDL_GetTicks();
  bookmark = (stopTime - startTime) / 1000.0;
  stop();
}

void SniperBGM::grab()
{
  /* Try to resume BGM after reopening sound device. */
  start();
  jumpto(bookmark);
  startTime -= (int)(bookmark * 1000); /* For next pause. */
}


SniperBGM gAudioBGM;


static void BGM_loop()
{
  gAudioBGM.loop();
}





static int
parse_option(PETOPT *pp,
	     PETOPTS *pov,
	     const char *arg)
{
	switch (pov->s) {
		case 'n': // no audio
		    gPrefs.audio = 0;
		    break;
		case 'f': // fullscreen
		    gPrefs.fullscreen = 1;
		    break;
		case 'w': // window
		    gPrefs.fullscreen = 0;
		    break;
		case 'a': // audio
		    gPrefs.audio = 1;
		    break;
		case '1':
				gPrefs.difficulty = 1;
		break;
		case '2':
				gPrefs.difficulty = 2;
				break;
		case '3':
				gPrefs.difficulty = 3;
				break;		
 		case 'h':
      fprintf (stderr, usage, invocation);
		  exit (0);
		}
}

void parse_args(int argc, char **argv)
{
	int fs, au, ds, petopt_err, i;
PETOPTS pov[] =
	{
  	  { 'n', POF_BOOL,        "noaudio",		 &au,  "Disable Audio"            },
    	{ 'f', POF_BOOL,      	"fullscreen",	 &fs,  "Enable Fullscreen"        },
    	{ 'w', POF_BOOL,      	"windowed",	   &fs,  "Disable Fullscreen"       },
    	{ 'a', POF_BOOL,        "audio",		   &au,  "Enable Audio"             },
    	{ '1', POF_OPT|POF_INT,	"diff1", 	     &ds,  "Difficulty Setting 1"     },
    	{ '2', POF_OPT|POF_INT,	"diff2", 	     &ds,  "Difficulty Setting 2"     },
    	{ '3', POF_OPT|POF_INT,	"diff3", 	     &ds,  "Difficulty Setting 3"     },
    	{ 'h', 0, 		          "help",	    	 NULL, "Extended mode"            }
	};
	PETOPT *pop;

	petopt_err = petopt_setup (&pop, 0, argc, argv, pov, parse_option, NULL);
	if (petopt_err > 0) {
			fprintf (stderr, "Unable to initialise petopt: %s\n", strerror(petopt_err));
			exit (1);
	}
	petopt_err = petopt_parse (pop, &argc, &argv);
	if (petopt_err > 0) {
	  fprintf(stderr, "petopt_parse_all: %s\n", strerror(petopt_err));
		exit(1);
  }
	petopt_cleanup (pop);
	
	return;
}

void reinit()
{

    gMouseX = 0;
    gMouseY = 0;
    gMouseZ = 1.0f;
    gCoordScale = 1.0f;
    gWobbleX = 0;
    gWobbleY = 0;
    gCenterX = 0;
    gCenterY = 0;
    gControlState = 0;
    gReloading = 0;
    gScore = 0;
    gVIPCount = 0;
    gBadGuyCount = 0;
    gWobbleIndex = 0;
    gVIPsGottenToSafety = 0;
    gPedestriansKilled = 0;
    gBadGuisKilled = 0;
    gSightedCharacter = NULL;

    int i;
    for (i = 0; i < gCharacterCount; i++)
    {
        gCharacter[i].mType = -1;
    }
    for (i = 0; i < (int)(gCharacterCount * 0.75f); i++)
    {
        int id = spawn_ai(2);
        int j;
        for (j = 0; j < 1000; j++) // Run 1000 physics loops for all pedestrians..
            handle_ai(gCharacter[id]);
    }
    gVIPSpawnTime = 2000;
    gVIPSpawnTimePeriod = 20000;
    gBadGuySpawnTime = 3000;
    gBadGuySpawnTimePeriod = 8000;
    gWobbleIndex = 0;
    gStartTick = SDL_GetTicks();
    gFrameCount = 0;
    gLastTick = SDL_GetTicks();
    gGameState = 1;
    gGameStartTick = SDL_GetTicks();
    SDL_ShowCursor (0);
}

void init()
{
    const char *city_img = "citee2.png";
    const char *charseq_img = "charseq.png";
    const char *aimap_img = "aimap.png";
    const char *font_img = "font4x6.png";

    const char *zoomin_snd = "camera_in.wav";
    const char *zoomout_snd = "camera_out.wav";
    const char *boing_snd = "twang.wav";
    const char *bgmusic = "oes.ogg";

    char path[ strlen(mediaPath) + 1 + 30 + 1 ];

    sprintf(path, "%s/%s", mediaPath, city_img);
    SDL_Surface *temp = IMG_Load(path);
    gMap = SDL_ConvertSurface(temp, gScreen->format,SDL_SWSURFACE);
    SDL_FreeSurface(temp);
    
    sprintf(path, "%s/%s", mediaPath, charseq_img);
    temp = IMG_Load(path);
    gCharSprite = SDL_ConvertSurface(temp, gScreen->format,SDL_SWSURFACE);
    SDL_FreeSurface(temp);

    gButton.startgame = oes_load_img ("newgame.png");
    gButton.startgameh = oes_load_img ("newgameh.png");
    gButton.fullscreen = oes_load_img ("fullscreen.png");
    gButton.fullscreenh = oes_load_img ("fullscreenh.png");
    gButton.window = oes_load_img ("window.png");
    gButton.windowh = oes_load_img ("windowh.png");
    gButton.audioon = oes_load_img ("audioon.png");
    gButton.audiooff = oes_load_img ("audiooff.png");
    gButton.audioonh = oes_load_img ("audioonh.png");
    gButton.audiooffh = oes_load_img ("audiooffh.png");
    gButton.easy = oes_load_img ("easy.png");
    gButton.easyh = oes_load_img ("easyh.png");
    gButton.medium = oes_load_img ("medium.png");
    gButton.mediumh = oes_load_img ("mediumh.png");
    gButton.hard = oes_load_img ("hard.png");
    gButton.hardh = oes_load_img ("hardh.png");
    gButton.hiscores = oes_load_img ("highscores.png");
    gButton.hiscoresh = oes_load_img ("highscoresh.png");
    gButton.prefs = oes_load_img ("prefs.png");
    gButton.prefsh = oes_load_img ("prefsh.png");
    gButton.quit = oes_load_img ("quit.png");
    gButton.quith = oes_load_img ("quith.png");
    gButton.resume = oes_load_img ("resumegame.png");
    gButton.resumeh = oes_load_img ("resumegameh.png");

    sprintf(path, "%s/%s", mediaPath, aimap_img);
    gAIMap = IMG_Load(path);
    
    // Okay, this is ugly. Load font several times & change the color of each.
    
    int i;
    for (i = 0; i < 5; i++)
    {
    	sprintf(path, "%s/%s", mediaPath, font_img);
        gFont[i] = IMG_Load(path);
        SDL_SetColorKey(gFont[i],SDL_SRCCOLORKEY,1); // set color index 1 (black) transparent
    }
    *(int*)&(gFont[0]->format->palette->colors[0]) = 0x000000; // black
    *(int*)&(gFont[1]->format->palette->colors[0]) = 0xffffff; // white
    *(int*)&(gFont[2]->format->palette->colors[0]) = 0x00ff00; // green
    *(int*)&(gFont[3]->format->palette->colors[0]) = 0x00ffff; // yellow
    *(int*)&(gFont[4]->format->palette->colors[0]) = 0x0000ff; // red
    
    precalc_ai();
    
    gCharacter = new CHARACTER[2048];
    gCharacterCount = 2048;

    
#ifdef PLAY_AUDIO
    if (gPrefs.audio)
	{
	    sprintf(path, "%s/%s", mediaPath, zoomin_snd);
	    gAudioZoomIn = Mix_LoadWAV(path);
	    sprintf(path, "%s/%s", mediaPath, zoomout_snd);
	    gAudioZoomOut = Mix_LoadWAV(path);
	    sprintf(path, "%s/%s", mediaPath, boing_snd);
	    gAudioFire = Mix_LoadWAV(path);
	    sprintf(path, "%s/%s", mediaPath, bgmusic);
	    gAudioBGM = Mix_LoadMUS(path);
	    
//	    SDL_PauseAudio(0); // let it play
	}
#endif
    reinit();
}

#define PHYSICS_MS 10
// 10ms physics loops == 100 loops per sec, 'should be enough'..

void reindeer()
{    
    gSightedCharacter = NULL;
    int tick = SDL_GetTicks();    
    gFrameCount++;
    if (gReloading)
    {
        gReloading -= tick - gLastTick;
        if (gReloading < 0)
            gReloading = 0;
    }
    
    gCenterX = (640.0f - 640.0f * gCoordScale) / 2;
    gCenterY = (480.0f - 480.0f * gCoordScale) / 2;
    gWobbleX = (float)(sin(gWobbleIndex * 0.000654387) + 
        sin(gWobbleIndex * 0.000547867)*2 + 
        sin(gWobbleIndex * 0.000700133)) * (WOBBLE / 4.0f);
    gWobbleY = (float)(sin(gWobbleIndex * 0.000537234) + 
        sin(gWobbleIndex * 0.000732897) + 
        sin(gWobbleIndex * 0.000600613)*2) * (WOBBLE / 4.0f);
    
    
    
#ifdef UNREAL_DITHER
    zoom_unreal(gMap, gMouseX + gCenterX + gWobbleX, gMouseY + gCenterY + gWobbleY, gCoordScale);    
#else
    zoom(gMap, gMouseX + gCenterX + gWobbleX, gMouseY + gCenterY + gWobbleX, gCoordScale);    
#endif   
    
    int i;
    int physics_loops = (tick - gLastTick) / PHYSICS_MS;
    int j;
    for (i = 0; i < gCharacterCount; i++)
    {
        for (j = 0; j < physics_loops; j++)
            handle_ai(gCharacter[i]);
        if (!gGameState)
            return;
        drawCharacter(gCharacter[i]);
    }
    
    target();
    
    for (j = 0; j < physics_loops; j++)
    {
        int physicstick = gLastTick - gGameStartTick;
        gWobbleIndex += PHYSICS_MS;
        
        // spawn VIPs
        if (physicstick >= gVIPSpawnTime)
        {
            
            if (gVIPCount == 2 && rand() < 2048)
                spawn_ai(1);
            if (gVIPCount == 1 && rand() < 8192)
                spawn_ai(1);
            if (gVIPCount == 0)            
                spawn_ai(1);
            gVIPSpawnTime += (int)gVIPSpawnTimePeriod;
        }
        // spawn baddies
        if (physicstick >= gBadGuySpawnTime)
        {
            spawn_ai(0);
            gBadGuySpawnTime += (int)gBadGuySpawnTimePeriod;
        }
        if (((gLastTick / PHYSICS_MS) & 3) == 0) 
            gBadGuySpawnTimePeriod--;
        
        if (gBadGuySpawnTimePeriod < 3000)
            gBadGuySpawnTimePeriod = 3000; // Eventually it will be impossible to kill all bad guys.
        
        gLastTick += PHYSICS_MS;     
    }
    
    
    SDL_Flip(gScreen);    
}

#if 0
void audiomixer(void *userdata, Uint8 *stream, int len)
{
    int l = len / 2;
    short * buf = (short*)stream;
    memset(stream,0,len);
    if (gPlaySound & (1<<1))
    {
        gPlaySound &= ~(1<<1);
        gAudioZoomOfs = 0;
        gAudioZoomSample = gAudioZoomOut;
        gAudioZoomSampleLen = gAudioZoomOutLen;
    }
    if (gPlaySound & (1<<2))
    {
        gPlaySound &= ~(1<<2);
        gAudioZoomOfs = 0;
        gAudioZoomSample = gAudioZoomIn;
        gAudioZoomSampleLen = gAudioZoomInLen;
    }
    if (gPlaySound & (1<<3))
    {
        gPlaySound &= ~(1<<3);
        gAudioFireOfs = 0;
        gAudioFireSample = gAudioFire;
        gAudioFireSampleLen = gAudioFireLen;
    }
    if (gAudioZoomSample != NULL)
    {
        int n = l;
        if (n + gAudioZoomOfs > gAudioZoomSampleLen)
            n = gAudioZoomSampleLen - gAudioZoomOfs;
        int i;
        for (i = 0; i < n; i++)
            buf[i] = gAudioZoomSample[i + gAudioZoomOfs] / 2;
        gAudioZoomOfs += n;
        if (l != n)
        {
            gAudioZoomSample = NULL;
        }
    }
    if (gAudioFireSample != NULL)
    {
        int n = l;
        if (n + gAudioFireOfs > gAudioFireSampleLen)
            n = gAudioFireSampleLen - gAudioFireOfs;
        int i;
        for (i = 0; i < n; i++)
            buf[i] += gAudioFireSample[i + gAudioFireOfs] / 2;
        gAudioFireOfs += n;
        if (l != n)
        {
            gAudioFireSample = NULL;
        }
    }    
}
#endif /* 0 */

/* Sillily expensive, but faster. */
char chanuse[16];

void finish_sound (int chan)
{
  chanuse[chan] = 0;
}

void play_sound(int aSound)
{
    int chan;
    if (!gPrefs.audio)
	return;
//    SDL_LockAudio();
//    gPlaySound |= 1 << aSound;
//    SDL_UnlockAudio();
    /* Find a free channel. */
    for (chan = 0; (chan < 16) && (chanuse[chan]); chan++);
    if (chan >= 16) return; /* out of channels. */
    chanuse[chan] = 1;
    switch (aSound) {
	case 1:
	    Mix_PlayChannel(chan, gAudioZoomOut, 0);
	    break;
	case 2:
	    Mix_PlayChannel(chan, gAudioZoomIn, 0);
	    break;
	case 3:
	    Mix_PlayChannel(chan, gAudioFire, 0);
	    break;
    }
}


int open_audio ()
{
#ifdef PLAY_AUDIO
    if (gPrefs.audio)
	{
#if 1
	    /* XXX: take settings from prefs. */
	    if (Mix_OpenAudio(44100, AUDIO_S16, 2, 4096)) {
		printf("Mix_OpenAudio(): %s\n", Mix_GetError());
	    }
	    Mix_AllocateChannels(17);
	    Mix_ChannelFinished(finish_sound);
#else
	    SDL_AudioSpec *as = new SDL_AudioSpec;
	    as->freq = 44100;
	    as->format = AUDIO_S16;
	    as->channels = 2;
	    as->samples = 4096;
	    as->callback = audiomixer;
	    as->userdata = NULL;
	    if (SDL_OpenAudio(as, NULL) < 0)
		{
		    fprintf(stderr, "Unable to init SDL audio: %s\n", SDL_GetError());
		    exit(1);
		}
	    gAudioSpec = as;
#endif /* 0 */
	}
#endif
  return 0;
}

int close_audio()
{
  Mix_CloseAudio();
  return 0;
}


int oes_game_fullscreen(); /* forward declaration. */

/*
  Event handling in pause loop.
  Since non-game mode, uses SDL_WaitEvent instead of SDL_PollEvent().
  Returns 0 if pause mode terminates.

  // Way to go!  this complicates adding buttons to do shit when paused.
  // Oh well, just have to do that LATER.
*/
int oes_pause_loop ()
{
    SDL_Event event;
    int mouseUnpause = 0;

    while (SDL_WaitEvent(&event))
    {
        switch (event.type) {
        case SDL_KEYDOWN:
           if (event.key.keysym.sym == SDLK_p) return 0;
           if ((event.key.keysym.sym == SDLK_z) && (SDL_GetModState() & KMOD_CTRL)) {
             SDL_WM_IconifyWindow();
             return 1;
           }
           break;
        case SDL_KEYUP:
           if ((event.key.keysym.sym == SDLK_g) && (event.key.keysym.mod & KMOD_CTRL)) gGrabP = !gGrabP; /* Activates on unpause. */
           if ((event.key.keysym.sym == SDLK_RETURN) && (event.key.keysym.mod & KMOD_ALT)) oes_game_fullscreen();
           if (event.key.keysym.sym == SDLK_ESCAPE) return 0;
           break;
        case SDL_MOUSEBUTTONDOWN:
           if (event.button.button == SDL_BUTTON_LEFT) {
             if ((SDL_GetTicks() - mouseUnpause) < 500) {
               /* Double-click unpauses. */
               return 0;
             } else {
               mouseUnpause = SDL_GetTicks();
             }
           }
           break;
        case SDL_QUIT:
           return 0;
           break;
        }
        gLastTick=SDL_GetTicks();
    }
    return 0;
}

int oes_game_pause()
{
    gBeforePauseTick = SDL_GetTicks();
    gAudioBGM.release();
    close_audio();
    SDL_WM_GrabInput (SDL_GRAB_OFF); 
    SDL_ShowCursor(1);
    while (oes_pause_loop());
    if (gGrabP) {  /* Obnoxious to re-grab on unpause? */
        SDL_ShowCursor(0);
        SDL_WM_GrabInput (SDL_GRAB_ON); 
    }
    open_audio();
    gAudioBGM.grab();
    gAfterPauseTick = SDL_GetTicks();
    gGameStartTick += gAfterPauseTick-gBeforePauseTick;
    return 0;
}

int oes_game_state (int newstate)
{
	switch ((gGameState = newstate)) {
	case 0:
		/* need init */
		break;
	case 1:
		/* main game state. */
		break;
	case 2:
		/* paused state. */
		break;
	case 3:
		/* just unpaused.  Need re-init, transit to 1. */
		break;
	}
}

int oes_game_verbosity ()
{
	verbosity = (verbosity + 1) % 3;
	gPrefs.verbose = verbosity;
	return 0;
}

int oes_game_screenshot ()
{
	SDL_SaveBMP(SDL_GetVideoSurface(),"screenshot.bmp");
	screen_shot_number++;
	return 0;
}

int oes_game_fullscreen ()
{
	SDL_WM_ToggleFullScreen(gScreen);
	gPrefs.fullscreen = !gPrefs.fullscreen;
	return 0;
}

int oes_game_hide ()
{
	SDL_WM_IconifyWindow();
	oes_game_pause();
	return 0;
}

int oes_game_fire ()
{
	if (!gReloading) {
		play_sound(3);
		shoot();
	}
}

int oes_game_mousezoom (int pressed)
{
	// zooming mode
	gControlState = pressed;
}

/*
Alter input grab state.
0 = try to release
1 = try to grab
-1 = toggle whatever it is.
*/
int oes_game_grab (int newstate)
{
	int tryGrabState;

	if (SDL_GetVideoSurface()->flags & SDL_FULLSCREEN) {
		/* Don't release grab in fullscreen. */
		SDL_WM_GrabInput(SDL_GRAB_ON);
		SDL_ShowCursor(0);
		gGrabP = 1;
		return 0;
	}
	tryGrabState = (newstate == -1) ? !gGrabP : newstate;
	switch (tryGrabState) {
	case 0:
		SDL_WM_GrabInput(SDL_GRAB_OFF);
		gGrabP = 0;
		SDL_ShowCursor(1);
		break;
	case 1:
		SDL_ShowCursor(0);
		SDL_WM_GrabInput(SDL_GRAB_ON);
		gGrabP = 1;
		break;
	}
	return gGrabP;
}

int oes_game_zoom (float amt)
{
	float oldcoord = gCoordScale;

	gMouseZ += amt;
	if (gMouseZ > 1.25) gMouseZ = 1.25;
	if (gMouseZ < 0.05f) gMouseZ = 0.05f;
#ifndef CAMERA_STEPS
	gCoordScale = gMouseZ;
#else /* CAMERA_STEPS */
	gCoordScale = ((int)(gMouseZ * 4)) / 4.0f;
	if (gCoordScale < 0.05f) gCoordScale = 0.05f;
#endif /* CAMERA_STEPS */
	if (oldcoord < gCoordScale)
		play_sound(1);
	if (oldcoord > gCoordScale)
		play_sound(2);
	return 0;
}

int oes_game_mouse (int xrel, int yrel)
{
	if (!gGrabP) {
		/* A little confusing if not grabbed... */
		return 1;
	}
	switch (gControlState) {
	case 0:
		gMouseX += xrel * gCoordScale;
		gMouseY += yrel * gCoordScale;

		if (gMouseX < -320) gMouseX = -320;
		if (gMouseY < -240) gMouseY = -240;
		if (gMouseX > (800 - 320)) gMouseX = (800 - 320);
		if (gMouseY > (600 - 240)) gMouseY = (600 - 240);
		break;
	case 1:
		oes_game_zoom (yrel * 0.005f);
		break;
	} //case gControlState
	return 0;
}

int handle_game_events ()
{
	SDL_Event event;
	while ( SDL_PollEvent(&event) ) {
		switch (event.type) {
		case SDL_KEYDOWN:
			switch (event.key.keysym.sym) {
			case SDLK_v:
				oes_game_verbosity();
				break;
			case SDLK_p:
				oes_game_pause();
				break;
			case SDLK_s:
				oes_game_screenshot();
				break;
		}
		break;
		case SDL_KEYUP:
			switch (event.key.keysym.sym) {
			case SDLK_ESCAPE:
#ifdef DISPLAY_GAMEOVER_SCREEN
				gameoverscreen(0);
#else
				return 0;
#endif
				break;
			case SDLK_RETURN:
				if (SDL_GetModState() & KMOD_ALT) {
					oes_game_fullscreen();
				}
				break;
			case SDLK_z:
				if (SDL_GetModState() & KMOD_CTRL) {
					oes_game_hide();
				}
				break;
			case SDLK_g:
				if (SDL_GetModState() & KMOD_CTRL) {
					oes_game_grab(-1);
				}
				break;
			} /* case SDL_KEYDOWN */
			break;
		case SDL_MOUSEMOTION:
			oes_game_mouse(event.motion.xrel, event.motion.yrel);
			break;
		case SDL_MOUSEBUTTONDOWN:
			switch (event.button.button) {
			case SDL_BUTTON_RIGHT:
				oes_game_mousezoom(1);
				break;
			case SDL_BUTTON_LEFT:
				oes_game_fire();
				break;
			// mousewheel.
			case 4:
				oes_game_zoom (-0.2f);
				break;
			case 5:
				oes_game_zoom (0.2f);
				break;
			}
			break;
		case SDL_MOUSEBUTTONUP:
			switch (event.button.button) {
			case SDL_BUTTON_RIGHT:
				// targeting mode
				gControlState = 0;
				break;
			}
			break;
                case SDL_QUIT:
			return(0);
			break;
		default:
			break;
		} //switch event.type
	} //while SDL_PollEvent
	return 0;
}


int main(int argc, char *argv[])
{
    srand(SDL_GetTicks());
   
    mediaPath = new char[ strlen(argv[0]) ];
    sprintf(mediaPath, "%s", dirname(argv[0]));
    invocation = argv[0];

    load_prefs();
    verbosity = gPrefs.verbose;
    parse_args(argc, argv);
    configure_difficulty();
    init_hiscores();
    
    //if ( SDL_Init(SDL_INIT_VIDEO | SDL_INIT_NOPARACHUTE) < 0 ) 
    if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) 
    {
        fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
        exit(1);
    }
    
    atexit(SDL_Quit);
    
    //gScreen = SDL_SetVideoMode(640, 480, 16, SDL_SWSURFACE); 
#ifdef OSX_SUX
    gScreen = SDL_SetVideoMode(640, 480, 16, (gPrefs.fullscreen ? SDL_FULLSCREEN : 0) | SDL_SWSURFACE);
#else
    gScreen = SDL_SetVideoMode(640, 480, 16, (gPrefs.fullscreen ? SDL_FULLSCREEN : 0) | SDL_SWSURFACE | SDL_DOUBLEBUF);
#endif
    SDL_WM_SetCaption("ORBITAL EUNUCHS SNIPER", "ORBITAL_EUNUCHS_SNIPER");
    if (gScreen == NULL) 
    {
        fprintf(stderr, "Unable to set 640x480 video: %s\n", SDL_GetError());
        exit(1);
    }
    set_crosshair_cursor();
    init_logoscreen();
    
    open_audio();
    
#ifdef DISPLAY_LOGO_SCREEN
    logoscreen();
#else
    init();
#endif

    oes_game_grab(1);
    
    gGameStartTick = SDL_GetTicks();
    gLastTick = gGameStartTick;
    
    gAudioBGM.stimulate();
    while (1)
    {
        if (!gGameState)
	{
            reinit();
	    gAudioBGM.stimulate();
	}
        reindeer();
        if (gGameState)
        {
	    handle_game_events();
        } //if gGameState
    } //while (1)
    delete[] mediaPath;

    close_audio();
    return 0;
}

void update_prefs()
{
    gPrefs.verbose = verbosity;
}

void configure_difficulty()
{
    gPrefs.difficulty = (gPrefs.difficulty < 1 ? 1 : gPrefs.difficulty);
    gPrefs.difficulty = (gPrefs.difficulty > 3 ? 3 : gPrefs.difficulty);
    switch (gPrefs.difficulty)
	{
	case 1:
	    RELOAD_TIME = 1500;
	    SCORE_MOD = 1.5;
	    break;
	case 2:
	    RELOAD_TIME = 3000;
	    SCORE_MOD = 1.0;
	    break;
	case 3:
	    RELOAD_TIME = 4000;
	    SCORE_MOD = 0.5;
	    break;
	}
}

void draw_button (SDL_Surface *b, int x, int y)
{
    SDL_Rect d;

    d.x = x;
    d.y = y;
    d.h = 32;
    d.w = 196;

    SDL_BlitSurface (b, NULL, gScreen, &d);
}

SDL_Surface *oes_load_img (char *path)
{
    SDL_Surface *sfc = NULL;
    char lpath[PATH_MAX];
    snprintf (lpath, PATH_MAX, "%s/%s", mediaPath, path);
    sfc = IMG_Load (lpath);
    if (!sfc) {
	std::cerr << "Unable to load image: " << SDL_GetError() << std::endl;
	exit (1);
    }
    return sfc;
}

bool hovering (int x, int y, int w, int h)
{
    int lx, ly;
    SDL_GetMouseState (&lx, &ly);
    if ((lx > x) && (ly > y) &&
	(lx < x + w) && (ly < y + h))
	return true;
    return false;
}

