///////////////////////////////////////////////
// 
//  Snipe2d ludum dare 48h compo entry
//
//  Jari Komppa aka Sol 
//  http://iki.fi/sol
// 
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
//
///////////////////////////////////////////////
//
// Houses are taken from a satellite picture of glasgow.
//
// The sources are a mess, as I didn't even try to do anything
// really organized here.. and hey, it's a 48h compo =)
//
//#include <windows.h>
#include <iostream>
#include <linux/limits.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <libgen.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "petopt.h"

// When trying to debug a segfault, you REALLY, REALLY need to be able to
// switch windows.  :(
#ifdef DEBUG_MODE
#undef SDL_GRAB_ON
#define SDL_GRAB_ON SDL_GRAB_OFF
#endif
// Config:

#define SHIFT_AMOUNT 12
#define CAMERA_STEPS
#define UNREAL_DITHER
#define WOBBLE 2
extern int RELOAD_TIME;
#define DISPLAY_LOGO_SCREEN
#define DISPLAY_GAMEOVER_SCREEN
//#define CAMERA_RECOIL
//#define RECYCLE_PEDESTRIANS
#define PLAY_AUDIO

enum COLORSET {
    COLOR_BLACK = 0,
    COLOR_WHITE,
    COLOR_GREEN,
    COLOR_YELLOW,
    COLOR_RED
};

enum CHARTYPES
{
    CHAR_BADGUY = 0,
    CHAR_VIP = 1,
    CHAR_PEDESTRIAN = 2
};

enum SOUNDCHAN {
  SOUNDCHAN_EFFECT = 0,
  SOUNDCHAN_MUSIC = 1,
};

extern SDL_Surface *gScreen;
extern SDL_Surface *gMap;
extern SDL_Surface *gAIMap;
extern SDL_Surface *gFont[5];
extern SDL_Surface *gCharSprite;
extern float gMouseX, gMouseY, gMouseZ, gCoordScale;
extern float gWobbleX, gWobbleY, gCenterX, gCenterY;
extern int gControlState;
extern int gStartTick;
extern int gGameStartTick;
extern int gFrameCount;
extern int gLastTick;
extern int gScore;
extern int gPedestrianSpawnCount;
extern int gVIPSpawnCount;
extern int gBadGuySpawnCount;
extern int gPedestriansKilled;
extern int gBadGuisKilled;
extern int gVIPsGottenToSafety;
extern float gVIPSpawnTime;
extern float gVIPSpawnTimePeriod;
extern float gBadGuySpawnTime;
extern float gBadGuySpawnTimePeriod;
extern int gWobbleIndex;
extern SDL_AudioSpec *gAudioSpec;
extern int unreal_dither[];
extern int gGameState;
extern char *mediaPath;

extern void print(int aXofs, int aYofs, int aColor, const char *aString, ...);
extern void printShadow(int aXofs, int aYofs, const char *aString, ...);
extern void zoom(SDL_Surface * src, float ofsx, float ofsy, float scale);
extern void zoom_unreal(SDL_Surface * src, float ofsx, float ofsy, float scale);
extern void drawLine(SDL_Surface * aTarget, int x1,int y1,int x2, int y2, int clr);
extern void target();
extern void init();
extern void init_logoscreen();
extern void logoscreen();
extern void precalc_ai();
extern void shoot();
extern void gameoverscreen(int aReason);

typedef struct character_
{
    float mX, mY; // position
    float mXi, mYi; // direction
    float mSpeed;   // speed of this AI
    int mType;   // AI type
    int mTTL;    // time to live, for normal pedestrians
    int mTarget; // target exit point or target character
    int mNextWaypoint;   // waypoint towards which this AI is walking
    int mLastWaypoints[7];   // last 7 waypoints to kill loops
    int mLastWaypoint;  // counter for above array
} CHARACTER;

typedef struct waypointstruc
{
    int mX,mY;
    int *mConnection;
    int mConnections;
} WAYPOINT;

typedef struct spawnpointstruc
{
    int mX, mY;
    int mClosestWaypoint;
    int mType;
} SPAWNPOINT;

typedef struct prefs_
{
    char *path;
    FILE *f;
    char verbose;
    char fullscreen;
    char audio;
    char difficulty;
} PREFS;

typedef struct scores_
{
    char easy_n[10][9];
    int easy_s[10];
    char medium_n[10][9];
    int medium_s[10];
    char hard_n[10][9];
    int hard_s[10];
} SCORES;

typedef struct BUTTONS {
    SDL_Surface *startgame;
    SDL_Surface *startgameh;
    SDL_Surface *fullscreen;
    SDL_Surface *fullscreenh;
    SDL_Surface *window;
    SDL_Surface *windowh;
    SDL_Surface *audioon;
    SDL_Surface *audiooff;
    SDL_Surface *audioonh;
    SDL_Surface *audiooffh;
    SDL_Surface *easy;
    SDL_Surface *easyh;
    SDL_Surface *medium;
    SDL_Surface *mediumh;
    SDL_Surface *hard;
    SDL_Surface *hardh;
    SDL_Surface *hiscores;
    SDL_Surface *hiscoresh;
    SDL_Surface *prefs;
    SDL_Surface *prefsh;
    SDL_Surface *quit;
    SDL_Surface *quith;
    SDL_Surface *resume;
    SDL_Surface *resumeh;
} BUTTONS;

extern BUTTONS gButton;
extern int gCharacterCount;
extern CHARACTER * gCharacter;
extern SPAWNPOINT *gSpawnpoint;
extern WAYPOINT *gWaypoint;
extern int gWaypointCount;
extern int gSpawnpointCount;
extern int gReloading;
extern CHARACTER * gSightedCharacter;
extern BUTTONS gButton;

extern float distance(float aX1, float aY1, float aX2, float aY2);
extern float distance(int aWaypoint, float aX, float aY);
extern float distance(int aWaypoint1, int aWaypoint2);
extern void handle_ai(CHARACTER &c);
extern int spawn_ai(int aType);

extern int gPedestrianSpawnCount;
extern int gVIPSpawnCount;
extern int gBadGuySpawnCount;

extern int gVIPCount;
extern int gBadGuyCount;

extern int verbosity;
extern float SCORE_MOD;

extern void drawCharacter(CHARACTER &c);

extern void new_prefs();
extern void load_prefs();
extern void save_prefs();
extern void update_prefs();
extern void configure_difficulty();

extern void show_hiscores();
extern void init_hiscores();
extern void process_hiscore();
extern void save_hiscores();

extern void prefs();


class SniperBGM {
    Mix_Music *BGM;
    int playp;
    int pausep;
    int startTime, stopTime;
    float bookmark;
    static const int FadeInTime = 3000;
    static const int FadeOutTime = 1000;
    static const float RepeatJumpPos = 0.0;
  public:
    SniperBGM();
    SniperBGM(Mix_Music *m);
    ~SniperBGM();
    const SniperBGM & operator=(Mix_Music *m);
    operator Mix_Music*() const;
    void use(Mix_Music *m);
    void start();
    void stimulate();
    void depress();
    void stop();
    void pause();
    void pause(int newstate);
    void jumpto(float pos);
    void rewind();
    void loop();
    void release();
    void grab();
};

void draw_button (SDL_Surface *b, int x, int y);

// FIXME:  everybody should use this.
SDL_Surface *oes_load_img (char *path);

bool hovering (int x, int y, int w, int h);
